var selected;

$(document).ready(function() {
	setRangeLabels();	
	$(".repetable_fieldset").hide();
	
	/* Colors */
	initColorPicker('#global-colors-picker' , '#fieldset-colors input');	
	initColorPicker('#default-point-color-picker', '#edit-default-point-color');
	initColorPicker('#range-color-picker' , 'fieldset#range-fieldset .range-color-input');	
	
	/* Regions */
	
	$('a#region-add').click(function() { 
		fieldsetAdd('region');
		return false;
	});	
	
	$('a.region-del').livequery('click', function() { 
		fieldsetDel('region', this);		
		return false;
	});	

	
	/* Ranges */
	
	$('a#range-add').click(function() { 				
		fieldsetAdd('range');
		setRangeLabels();
		initColorPicker('#range-color-picker', 'fieldset#range-fieldset .range-color-input');
		return false;
	});	
	
	$('a.range-del').livequery('click', function() { 
		fieldsetDel('range', this);
		setRangeLabels();
		return false;
	});	
	
	
	/* States */
	
	$('a#state-add').click(function() { 
		fieldsetAdd('state');
		return false;
	});	
	
	$('a.state-del').livequery('click', function() { 
		fieldsetDel('state', this);
		return false;
	});	

	/* Points */
	
	$('a#point-add').click(function() { 
		fieldsetAdd('point');
		return false;
	});	
	
	$('a.point-del').livequery('click', function() { 
		fieldsetDel('point', this);
		return false;
	});	
	
});

function fieldsetDel(type, delElement) {
	
	$(delElement).parent().parent().remove();
	
	var counter = 1;
	
	$("#" + type + "-fieldset div fieldset:gt(0)").each(function() {
		renumItems(this, counter);
	});

}

function fieldsetAdd(type) {
	
	var nbFieldset = $("#" + type + "-fieldset div fieldset").size();
	var fromClone = $("#" + type + "-fieldset--0").clone();
    
	$(fromClone).show();
	renumItems(fromClone, nbFieldset);
	$("#" + type + "-add").before(fromClone);

}

function setRangeLabels() {	
	$('#range-fieldset div fieldset label').hide();
	$('#range-fieldset div fieldset:eq(1) label').show();
}

function renumItems(fieldset, toNum) {
	
	$(fieldset).attr('id', $(fieldset).attr('id').replace(/--\d+/, '--' + toNum ) );
	$(fieldset).find('div').each(function () {
		$(this).attr('id', $(this).attr('id').replace(/--\d+/, '--' + toNum ) );								
	});
	$(fieldset).find('label').each(function () {
		$(this).attr('for', $(this).attr('for').replace(/--\d+/, '--' + toNum ) );								
	});
	$(fieldset).find('input').each(function () {
		$(this).attr('id', $(this).attr('id').replace(/--\d+/, '--' + toNum ) );
		$(this).attr('name', $(this).attr('name').replace(/__\d+/, '__' + toNum ) );
	});
	$(fieldset).find('select').each(function () {
		$(this).attr('id', $(this).attr('id').replace(/--\d+/, '--' + toNum ) );
		$(this).attr('name', $(this).attr('name').replace(/__\d+/, '__' + toNum ) );
	});
	
}

function initColorPicker(colorPickerId, colorInputClass) {
	
	var f = $.farbtastic(colorPickerId);
	var p = $(colorPickerId).css('opacity', 0.25);
	
	$(colorInputClass)
		.each(function () { f.linkTo(this); $(this).css('opacity', 0.75); } )
		.livequery('focus', function() {
			if (selected) {
				$(selected).css('opacity', 0.75).removeClass('colorwell-selected');
			}
			f.linkTo(this);
			p.css('opacity', 1);
			$(selected = this).css('opacity', 1).addClass('colorwell-selected');
		});
}